<?php

namespace Drupal\commerce_affiliatly\EventSubscriber;

use Drupal\commerce_affiliatly\CommerceAffiliatly;
use Drupal\state_machine\Event\WorkflowTransitionEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class AffiliatlyOrderStatusSubscriber implements EventSubscriberInterface {

  private $commerceAffiliatly;

  public function __construct(CommerceAffiliatly $commerceAffiliatly) {
    $this->commerceAffiliatly = $commerceAffiliatly;
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return [
      'commerce_order.post_transition' => ['onOrderPostTransition'],
    ];
  }

  /**
   * Creates a log on order state update.
   *
   * @param \Drupal\state_machine\Event\WorkflowTransitionEvent $event
   *   The transition event.
   */
  public function onOrderPostTransition(WorkflowTransitionEvent $event) {

    /** @var \Drupal\commerce_order\Entity\OrderInterface $order */
    $order = $event->getEntity();
    if($order->getState()->getId() == "completed"){
      $this->commerceAffiliatly->sendTracking($order);
    }

  }
}
