<?php

namespace Drupal\commerce_affiliatly\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class AffiliatlySettingsForm extends ConfigFormBase {

  const CONFIG = 'commerce_affiliatly.settings';

  /**
   * Name of Editable Config.
   */
  protected function getEditableConfigNames() {
    return [self::CONFIG];
  }

  /**
   * Form id name.
   */
  public function getFormId() {
    return "commerce_affiliatly_settings";
  }

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   *
   * @return array
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config(self::CONFIG);
    $form['id_affiliatly'] = [
      '#type' => 'textfield',
      '#title' => 'ID affiliatly',
      '#default_value' => $config->get('id_affiliatly'),
      '#description' => 'You can find your code, when you login into your account at <a href="http://www.affiliatly.com" target="_blank">Affiliatly.com</a> and check tab "Integration", it should be something like AF-XXXXX',
      '#required' => TRUE,
    ];
    $form['security_hash'] = [
      '#type' => 'textfield',
      '#title' => 'Security Hash',
      '#default_value' => $config->get('security_hash'),
      '#description' => 'You can find your code, when you login into your account at <a href="http://www.affiliatly.com" target="_blank">Affiliatly.com</a> and check tab "Account", section Security hash',
      '#required' => TRUE,
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   *
   * @return void
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->config(self::CONFIG)
      ->set('id_affiliatly', $form_state->getValue('id_affiliatly'))
      ->set('security_hash', $form_state->getValue('security_hash'))
      ->save();
    parent::submitForm($form, $form_state);
  }

}
